from rect import Rect
from vector import Vector3
import character

class Attack (object):
  def __init__(self, damage, rect, force_x, force_y):
    self.damage = damage
    
    self.attack_rect = rect
    self.force = Vector3(force_x, force_y, 0)
    
    self.reverse_attack_rect = self.attack_rect.clone().neg_x()
    
    self.reverse_force = self.force.clone()
    self.reverse_force.x = -self.reverse_force.x
    
  def get_world_attack_rect(self, attacker):
    if attacker.facing == character.FACING_LEFT:
      world_attack_rect = self.reverse_attack_rect + attacker.get_centre()
      world_attack_rect.left += attacker.core_rect.left
      world_attack_rect.right += attacker.core_rect.left
    else:
      world_attack_rect = self.attack_rect + attacker.get_centre()
      world_attack_rect.left += attacker.core_rect.right
      world_attack_rect.right += attacker.core_rect.right
    
    return world_attack_rect

  def get_victims (self,attacker, world_attack_rect, possible_victims):
    r = []
    for victim in possible_victims:
      if victim.team != attacker.team:
        if abs(victim.pos.z - attacker.pos.z) < 5:
          if victim.get_world_core_rect().intersect(world_attack_rect):
            r.append(victim)
    return r
  
  def do_attack (self, attacker, possible_victims):
    world_attack_rect = self.get_world_attack_rect(attacker)
    for victim in self.get_victims(attacker, world_attack_rect, possible_victims):
      attacker.last_enemy_hit = victim
              
      if attacker.facing == character.FACING_LEFT:
        victim.hit (self.damage, self.reverse_force)
      else:
        victim.hit (self.damage, self.force)
    return world_attack_rect

attacks = {}
for line in file("data/attacks.txt"):
  line = line.strip()
  if line[0] == "#":
    continue
  
  name, damage, left, bottom, right, top, force_x, force_y = line.split()
  
  attack = Attack(int(damage), Rect(int(left), int(bottom), int(right), int(top)), int(force_x), int(force_y))
  attacks[name] = attack

