import pyglet
from pyglet.image import AnimationFrame

character_images = {}

image_grids = {}

def flip_image_grid(src):
  dst = []
  for image in src:
    dst.append (flip_image(image))
  return dst
def flip_image(src):
  src_data = src.get_image_data().get_data("RGBA",128)
  dst_data = src_data[:]
  for i in range (src.height):
    for j in range (src.width):
      pass
  return pyglet.image.ImageData (src.width,src.height,"RGBA",dst_data)

def add_image_grid (name, file_name, size_x, size_y, cell_x, cell_y):
  global image_grids
  image_grids[name] = pyglet.image.ImageGrid (pyglet.image.load(file_name%"right"), size_x, size_y,cell_x,cell_y)
  image_grids["Reversed_%s"%name] = pyglet.image.ImageGrid (pyglet.image.load(file_name%"left"), size_x, size_y,cell_x,cell_y)

add_image_grid ("player_frames",       "data/character_animation_frames_%s.png", 2,6,128,128)
add_image_grid ("player_misc_frames",       "data/character_animation_frames_misc_%s.png", 4,4,128,128)
add_image_grid ("henchman_frames",     "data/henchman_animation_frames_%s.png" , 4,4,128,128)

def add_animation(animation_name,image_grid_name, frame_list):
  global character_images
  image_grid = image_grids[image_grid_name]
  list = [AnimationFrame(image_grid[index],time) for index,time in frame_list]
  character_images [animation_name] = pyglet.image.Animation(list)
  flipped_image_grid = image_grids["Reversed_%s"%image_grid_name]
  list = [AnimationFrame(flipped_image_grid[index],time) for index,time in frame_list]
  character_images ["Reversed_%s"%animation_name] = pyglet.image.Animation(list)

add_animation ("Player_Standing" ,"player_misc_frames", [(8,1)])  
add_animation ("Player_Punching" ,"player_misc_frames", [(12,0.2),(13,1)])  
add_animation ("Player_Uppercut" ,"player_misc_frames", [(1,2)])  
add_animation ("Player_Kick" ,"player_misc_frames", [(9,0.2),(5,2)])  
add_animation ("Player_Roundhouse" ,"player_misc_frames", [(4,2)])  
add_animation ("Player_Stunned" ,"player_misc_frames", [(10,0.2),(11,0.2)])  
add_animation ("Player_Falling" ,"player_misc_frames", [(9,0.2)])  
add_animation ("Player_Running" ,"player_misc_frames", [(6,0.2)])  
add_animation ("Player_Walking" ,"player_frames", [(6,0.07),(7,0.07),(8,0.07),(9,0.07),(10,0.07),(11,0.07),(0,0.07),(1,0.07),(2,0.07),(3,0.07),(4,0.07),(5,0.07)])  

add_animation ("Enemy_Standing" ,"henchman_frames", [(0,0.1),(1,0.1)])  
add_animation ("Enemy_Punching" ,"henchman_frames", [(2,0.2),(3,1.0)])  
add_animation ("Enemy_Uppercut" ,"henchman_frames", [(2,0.1),(2,0.1)])  
add_animation ("Enemy_Kick" ,"henchman_frames", [(2,0.1),(2,0.1)])  
add_animation ("Enemy_Roundhouse" ,"henchman_frames", [(2,0.1),(2,0.1)])  
add_animation ("Enemy_Walking" ,"henchman_frames", [(0,0.1),(1,0.1)])  
add_animation ("Enemy_Stunned" ,"henchman_frames", [(4,0.1),(5,0.1)])  
add_animation ("Enemy_Falling" ,"henchman_frames", [(4,0.1),(5,0.1)])  
add_animation ("Enemy_Running" ,"henchman_frames", [(0,0.1),(1,0.1)])  

def make_split_up_image (dictionary, image, initial_name, height, section_width):
  width = image.width
  x_pos = 0
  n = 1
  while (x_pos < width):
    dictionary["%s%d"%(initial_name,n)] = image.get_region(x_pos,0,section_width,height)
    n += 1
    x_pos += section_width

#def flip_image_grids():
 # for i_key in image_grid:


def reverse_character_images():
  new_images = {}
  for image_name in character_images:
    image = character_images[image_name]
    new_images["Reverse_%s"%image_name] = flip_image(image)

#reverse_character_images()
    

background_images = {}

background_image_grid = pyglet.image.ImageGrid (pyglet.image.load("data/background_images.png"),8,8,64,64)
background_images["grass"] = background_image_grid[0]
background_images["stones"] = background_image_grid[1]
#background_images["foreground"] = pyglet.image.load("data/foreground.png")

make_split_up_image (background_images,pyglet.image.load("data/background_top_layer_snipped.png"),"foreground",600,800)

#background_images["foreground"] = pyglet.image.load("data/foreground.png")
#background_images["middleground"] = pyglet.image.load("data/middleground.png")
background_images["middleground"] = pyglet.image.load("data/background_midlayer2.png")
background_images["background"] = pyglet.image.load("data/background.png")

speech_bubble = pyglet.image.load("data/speech_bubble.png")

shadow = pyglet.image.load("data/shadow.png")





